//   RW Arigato
// ==============
// aka 'Robowaifu' - The Humanoid Female Robot Companion Library
// -Part of the RW Foundations suite of libraries

// Filename: ./src/arigato/arigato.cpp
// -Definitions of the baseline RW Arigato library

#include "incls_all.hpp"

namespace rw::arigato {

//------------------------------------------------------------------------------
Arigato_b::Arigato_b() : Arigato_b{"arigato_b_obj"} {}

//------------------------------------------------------------------------------
Arigato_b::Arigato_b(std::string const& handle)
    : Arigato_b{handle, Type::Arigato} {}

//------------------------------------------------------------------------------
Arigato_b::Arigato_b(const std::string& handle, const Type type)
    : RW{handle, type} {
  stamp("Arigato_b()");
}

//------------------------------------------------------------------------------
Arigato::Arigato() : Arigato{"arigato_obj"} {}

//------------------------------------------------------------------------------
Arigato::Arigato(std::string const& handle)
    : Arigato_b{handle, Type::Arigato} {}

//------------------------------------------------------------------------------
Arigato::Arigato(const std::string& handle, const Type type)
    // DESIGN:
    : Arigato_b{handle, /* any_of() here in init to validate? */ type} {
  // -UD: will also need to have a vector of acceptable types (spcly for ea.
  // base type), and then call a function defined (as a utility? RW?) to
  // validate the derived classes' claimed Type supplied, against the base
  // classes' vector of acceptable Types
  // -cf: chibitsu.cpp, L18

  stamp("Arigato()");
}

//------------------------------------------------------------------------------
Arigato::~Arigato() {}

//------------------------------------------------------------------------------
auto Arigato::do_preflight() -> bool {
  // TODO:
  // do actual initialization here. eg, turn off embedded object's unneeded
  // members, ensure filesets are available & ready, connections are working,
  // etc., etc., etc.  :^)
  //

  cout << hdl() << " checks out A-OK!\n";
  return true;  // TEMP:
}

}  // namespace rw::arigato

//    --=^=--

// "I only wish I could find a really cute one just lying around somewhere."

// rw_arigato_lib.v220219
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
