//  RW Mailstop
// ==============
// ______
// -Part of the RW Foundations suite of libraries

// Filename: ./src/dollhouse/net/mailstop.cpp
// -Definitions of the baseline RW Mailstop sub-library

///////
// Dolldrop/Dollnet is meant for network-enabled RW projects only
#if __has_include(<curl_easy.h>)

#include "incls_all.hpp"

#include "mailstop_util.cpp"

namespace rw::dollhouse::net {

//------------------------------------------------------------------------------
auto Dolldrop_b::Mailstop::try_hdr(Hip const& tag, std::string const& uri)
    -> std::stringstream {  //

  // DESIGN: TODO:

  // try {
  // TEMP: return dolldrop header directly for now
  return dollnet_.dl_hdr(tag, uri);

  // } catch (exception const& e) {
  //   cerr << "\n  exception '" << e.what() << "' caught in
  //   try_hdr()\n\n";
  // }
}

//------------------------------------------------------------------------------
auto Dolldrop_b::Mailstop::try_body(Hip const& tag, std::string const& uri)
    -> std::fstream {  //

  auto const dropname = chk_dropname(uri);
  ofstream   anons_file{dropname};

  try {
    dollnet_.dl_body(tag, uri, anons_file);

  } catch (exception const& e) {
    cerr << "\n  exception '" << e.what() << "' caught in try_body()\n\n";
  }

  anons_file.close();
  set_name(uri, dropname);

  // TEMP: return dolldrop body directly for now
  return fstream{dropname};
}

//------------------------------------------------------------------------------
auto Dolldrop_b::Mailstop::try_hdr_body(Hip const& tag, std::string const& uri)
    -> std::stringstream {  //

  auto const dropname = build_dropname();
  ofstream   anons_file{dropname};

  // DESIGN: TODO:

  // try {
  auto hdr = dollnet_.dl_hdr_body(tag, uri, anons_file);

  // } catch (exception const& e) {
  //   cerr << "\n  exception '" << e.what() << "' caught in
  //   try_hdr_body()\n\n";
  // }

  anons_file.close();
  set_name(uri, dropname);

  // TEMP: return dolldrop header directly for now
  return hdr;
}

}  // namespace rw::dollhouse::net

#endif  // __has_include(<curl_easy.h>)

//    --=^=--

// "______"

// rw_dollhouse_lib.v220219
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
